;=========================================================;
; FPS TEST                                       05/08/06 ;
;---------------------------------------------------------;
;                                                         ;
; Assemble C:\Fasm FpsTest.ASM FpsTest.dex                ;
;=========================================================;
use32
	ORG   0x400000				       ; where our program is loaded to
	jmp   start				       ; jump to the start of program.
	db    'DEX2'				       ; We check for this, to make shore it a valid Dex4u file.
msg1:	db " Vesa mode not supported",13
	db " Press any key to exit. ",13,0 
 ;----------------------------------------------------;
 ; Start of program.                                  ;
 ;----------------------------------------------------;
start:

	mov   ax,18h
	mov   ds,ax
	mov   es,ax
 ;----------------------------------------------------;
 ; Get calltable address.                             ;
 ;----------------------------------------------------;
	mov   edi,Functions			       ; this is the interrupt
	mov   al,0				       ; we use to load the DexFunction.inc
	mov   ah,0x0a				       ; with the address to dex4u functions.
	int   40h
 ;----------------------------------------------------; 0x4118 0x411B 0x4115 0x4112
 ; Do realmode int (vesa).                            ;
 ;----------------------------------------------------;
	mov   ecx,0x4115
	call  [SetVesaMode]
	cmp   ah,1
	je    VesaError1
 ;----------------------------------------------------;
 ; Load vesa info.                                    ;
 ;----------------------------------------------------;
	call  [LoadVesaInfo]
	mov   edi,VESA_Info
	mov   ecx,193
	cld
	cli
	rep   movsd
	sti
	mov   eax,0x00ffffff
	call  FillScreenColor			       ; Fill the buffer with one color
	mov   al,0x0				       ; Test for seconds
	out   0x70,al
	in    al,0x71
	mov   [lastSecondTick],al		       ; Store second count, to use later
	mov   [FpsCount],0
FpsLoop:					       ; Main loop, that loops untill keypress
	call  PrintFPS				       ; check if a second as passed, if so print FPS
	call  BuffToScreen			       ; dump the back buffer to screen
	inc   [FpsCount]			       ; inc counter
	call  [KeyPressedNoWait]		       ; check for keypress, if not loop.
	cmp   al,0
	je    FpsLoop
ExitHere:
	call  [SetDex4uFonts]			       ; Change back to text mode before exiting
	ret

 ;----------------------------------------------------;
 ; Display Vesa Error message.                        ;
 ;----------------------------------------------------;
VesaError1:
	call  [SetDex4uFonts]
	mov   esi,msg1
	call  [PrintString]
	call  [WaitForKeyPress]
	ret

 ;'''''''''''''''''''''''''''''''''''''''''''''''''''';
 ; FillScreenColor (buffer)                           ;
 ;----------------------------------------------------;
 ;                                                    ;
 ;  Input:   eax = color                              ;
 ;                                                    ;
 ;                                                    ;
 ; Output:                                            ;
 ;                                                    ;
 ;....................................................;
FillScreenColor:
	pushad
	mov  edi,VesaBuffer
	xor  ecx,ecx
	mov  cx,[ModeInfo_YResolution]
FillScreenColorLoop:
	push ecx
	xor  ecx,ecx
	mov  cx,[ModeInfo_XResolution]
	cld
	rep  stosd
	pop  ecx
	loop FillScreenColorLoop
	popad
	ret

 ;'''''''''''''''''''''''''''''''''''''''''''''''''''';
 ; FillScreenColorSmall (buffer)                      ;
 ;----------------------------------------------------;
 ;                                                    ;
 ;  Input:   eax = color                              ;
 ;                                                    ;
 ;                                                    ;
 ; Output:                                            ;
 ;                                                    ;
 ;....................................................;
FillScreenColorSmall:
	pushad
	mov  edi,VesaBuffer
	xor  ecx,ecx
	mov  cx,20
FillScreenColorLoopS:
	push ecx
	xor  ecx,ecx
	mov  cx,[ModeInfo_XResolution]
	cld
	rep  stosd
	pop  ecx
	loop FillScreenColorLoopS
	popad
	ret

 ;----------------------------------------------------;
 ; Data.                                              ;
 ;----------------------------------------------------;

include 'FPS.inc'
include 'VesaText.inc'
include 'Font16.inc'

lastSecondTick	db 0
FpsCount	dw 0
count		db 0
align 4
include 'Dex.inc'
align 4
VesaBuffer1 rd	800*600*2
align 4
VesaBuffer: